/* LCM type definition class file
 * This file was automatically generated by lcm-gen
 * DO NOT MODIFY BY HAND!!!!
 */

package exlcm;
 
import java.io.*;
import java.util.*;
import lcm.lcm.*;
 
public final class gps implements lcm.lcm.LCMEncodable
{
    public double timestamp;
    public exlcm.latitude_t latitude;
    public exlcm.longitude_t longitude;
    public exlcm.altitude_t altitude;
    public double utm_x;
    public double utm_y;
 
    public gps()
    {
    }
 
    public static final long LCM_FINGERPRINT;
    public static final long LCM_FINGERPRINT_BASE = 0x6eebbf0c7fafe945L;
 
    static {
        LCM_FINGERPRINT = _hashRecursive(new ArrayList<Class<?>>());
    }
 
    public static long _hashRecursive(ArrayList<Class<?>> classes)
    {
        if (classes.contains(exlcm.gps.class))
            return 0L;
 
        classes.add(exlcm.gps.class);
        long hash = LCM_FINGERPRINT_BASE
             + exlcm.latitude_t._hashRecursive(classes)
             + exlcm.longitude_t._hashRecursive(classes)
             + exlcm.altitude_t._hashRecursive(classes)
            ;
        classes.remove(classes.size() - 1);
        return (hash<<1) + ((hash>>63)&1);
    }
 
    public void encode(DataOutput outs) throws IOException
    {
        outs.writeLong(LCM_FINGERPRINT);
        _encodeRecursive(outs);
    }
 
    public void _encodeRecursive(DataOutput outs) throws IOException
    {
        outs.writeDouble(this.timestamp); 
 
        this.latitude._encodeRecursive(outs); 
 
        this.longitude._encodeRecursive(outs); 
 
        this.altitude._encodeRecursive(outs); 
 
        outs.writeDouble(this.utm_x); 
 
        outs.writeDouble(this.utm_y); 
 
    }
 
    public gps(byte[] data) throws IOException
    {
        this(new LCMDataInputStream(data));
    }
 
    public gps(DataInput ins) throws IOException
    {
        if (ins.readLong() != LCM_FINGERPRINT)
            throw new IOException("LCM Decode error: bad fingerprint");
 
        _decodeRecursive(ins);
    }
 
    public static exlcm.gps _decodeRecursiveFactory(DataInput ins) throws IOException
    {
        exlcm.gps o = new exlcm.gps();
        o._decodeRecursive(ins);
        return o;
    }
 
    public void _decodeRecursive(DataInput ins) throws IOException
    {
        this.timestamp = ins.readDouble();
 
        this.latitude = exlcm.latitude_t._decodeRecursiveFactory(ins);
 
        this.longitude = exlcm.longitude_t._decodeRecursiveFactory(ins);
 
        this.altitude = exlcm.altitude_t._decodeRecursiveFactory(ins);
 
        this.utm_x = ins.readDouble();
 
        this.utm_y = ins.readDouble();
 
    }
 
    public exlcm.gps copy()
    {
        exlcm.gps outobj = new exlcm.gps();
        outobj.timestamp = this.timestamp;
 
        outobj.latitude = this.latitude.copy();
 
        outobj.longitude = this.longitude.copy();
 
        outobj.altitude = this.altitude.copy();
 
        outobj.utm_x = this.utm_x;
 
        outobj.utm_y = this.utm_y;
 
        return outobj;
    }
 
}

